generic
	Max_Elem : positive := 51;
	with function Pseudoclave(E: in TElemento) return Natural;
package Contenedores.Dispersin_Prueba_Lineal is
	type Tabla_Dispersin is new Contenedor with private;

	-- Operaciones heredadas de Contenedor
	procedure Insertar(C: in out Tabla_Dispersin;E: in TElemento);
	procedure Extraer(C: in out Tabla_Dispersin;E: in TElemento);
	procedure Vaciar(C: in out Tabla_Dispersin);
	function Est(C: in Tabla_Dispersin;E: in TElemento) return boolean;
	function Tamao(C: in Tabla_Dispersin) return Natural;

	-- Excepcin que indica que no queda espacio para insertar elementos.
	Contenedor_Lleno: exception;
private
	Type nodo is record
		Elemento: TElemento;
		Ocupado : Boolean := false;
	end record;

	Type Almacen is array(0..Max_Elem - 1) of Nodo;

	type Tabla_Dispersin is new Contenedor with record
		Elementos: Almacen;
		Num_Elem : Natural := 0;
    end record;
end Contenedores.Dispersin_Prueba_Lineal;
