package comn;

/**
 * @author juanca
 */
public class Conversor {
    public static final int INTBYTES=4;
    public static final int FLOATSBYTES=4;
    public static byte[] aByte(int dato){
        byte res[]= new byte[INTBYTES];
        long datol=dato-(long)Integer.MIN_VALUE; //Pasamos a nmeros positivos
        for(int i=0; i<INTBYTES; i++){ //Los 4 bytes de un int se toman mediante divisiones
          res[i]=(byte) ((datol%256)+Byte.MIN_VALUE); //Pasamos a con signo para almacenarlo
          datol/=256;
        }
        return res;
    }
    public static int aade(byte[] acumulado, byte[] datos, int pos) {
       for (int i = 0; i < datos.length; i++)
          acumulado[pos++] = datos[i];
       return pos;
    }
    public static byte[] toma(byte[] acumulado, int pos, int lon) {
       byte[] res = new byte[lon];
       for (int i = 0; i < lon; i++)
          res[i] = acumulado[pos++];
       return res;
    }
    public static byte[] aByte(float dato){
        return aByte(Float.floatToRawIntBits(dato));        
    }
    public static byte[] aByte(String dato, int lmite){
        if(dato.length()>lmite)
            dato=dato.substring(0,lmite-1);
        byte res[]=new byte[lmite];
        do{
            byte aux[]= dato.getBytes();
            if(aux.length<=lmite){
                for(int i=0; i <aux.length; i++) res[i]=aux[i];
                return res;
            }
            dato=dato.substring(0,dato.length()-1);
        }while(dato.length()>0);
        return null;
    }
    public static int aInt(byte dato[]){
        long res=0;
        for(int i=3; i>=0; i--){ //Los 4 bytes regeneran el int
            res*=256;
            res+=(long)dato[i]-Byte.MIN_VALUE; //Pasamos a positivo
        }
        return (int)(res+Integer.MIN_VALUE);//Pasamos a con signo   
    }
    public static float aFloat(byte dato[]){
        return Float.intBitsToFloat(aInt(dato));        
    }
    public static String aString(byte dato[]){
        return new String(dato);        
    }
}
