generic
	Max_Elem : positive := 51;
	with function Pseudoclave(E: in TElemento) return Natural;
package Contenedores.Dispersin_Cadenas_Separadas is
	type Tabla_Dispersin is new Contenedor with private;

	-- Operaciones heredadas de Contenedor
	procedure Insertar(C: in out Tabla_Dispersin;E: in TElemento);
	procedure Extraer(C: in out Tabla_Dispersin;E: in TElemento);
	procedure Vaciar(C: in out Tabla_Dispersin);
	function Est(C: in Tabla_Dispersin;E: in TElemento) return boolean;
	function Tamao(C: in Tabla_Dispersin) return Natural;

private
	type Nodo;
	type P_Nodo is access Nodo;
	type Nodo is record
		Elemento : TElemento;
		Siguiente: P_Nodo;
	end record;

	type Almacen is array(0..Max_Elem - 1) of P_Nodo;

	type Tabla_Dispersin is new Contenedor with record
		Elementos: Almacen;
		Num_Elem : Natural := 0;
    end record;
end Contenedores.Dispersin_Cadenas_Separadas;
